--[[

This file is part of RampageAI.

RampageAI is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

RampageAI is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with RampageAI; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

----------------------------
-- Homunculus Information --
----------------------------

HomunID = 0
OwnerID = 0
HomunType = 0
HomunSpecificType = 0
HomunAdvancedType = false
HomunRange = 0			-- Do not confuse with MaxHomunRange
HomunSkillRange = 10000
AIStartedAt = 0

-----------------------
-- Skill information --
-----------------------

-- Attack-skills
AttackSkills = Table.new()
RangedSkills = Table.new()
AttackSkillsByID = { }

-- Skill delay
LastAttackSkill = 0

-- Note: other skill types are handled by each specific homunculus type

---------------------------------
-- Alchemist Skill Information --
---------------------------------

--[[ Functions to check/cast skills, prioritized

	NOTE: Like the monster table, the higher the priority number,
		the higher the priority. eg, 1 is a lower priority than 10.
--]]
AlchSkillsTable = Table.new()

-- Auto-cast sword bolt delay
LastAlchAttackSkill = 0

-- Information about auto-alchemist skill usage
AlchAttackInfoHash = {
	Any = {
		Active = false,
		LastMutEx = "",
		NextMutExTime = 0,
		LastEvalTime = 0,
		DisableUntil = 0,
	},
}

-- Auto-Support Heal
SupportHealInfo = {
	Active=false,
	Target=0,
	Level=0,
	Ticks=0,
	SP=0,
	DmgCount=0,
}

-- Timeout and cast modifiers
CastModifier = 0
OwnerSkillTimeout = 0

-- Aid Pot's success/failure history
AidPotHistory = List.new()

-------------------
-- AI sequencing --
-------------------

AI_seq = List.new()
Mode = MODE_PASSIVE
OwnerLast = { X=0, Y=0, Motion=0, Dist=0, PortalDist=0,
		Attack=0, Move=0, Sit=0, Command=0, Pickup=0 }
HomunLast = { Attack = 0, Sequence = 0 }
HoldPosition = false
MaxDistance = 0
MaxDistanceTimeout = 0
OwnerMotion = 0
HomunMotion = 0
PVPZone = false
WoEZone = false				-- Also sets PVPZone to true
EnteringPortal = false			-- Disables all actions from the script

------------------
-- Position Lag --
------------------

PosLag = { }
PosLag.move = { x=0, y=0, ticks=0 }
PosLag.check = { x=0, y=0, ticks=0 }
PosLag.tries = { left=0, timeout=0, msg = { x=0, y=0 }, trying = false }

--------------------------
-- Targetting Variables --
--------------------------

AcquireTargetNextTime = 0
ActorData = { }
Target = { ID = -1, Previous = -1, Lock = false, Swap = 0,
		AttackLog = List.new(), TicksSpent = 0, LastTick = 0, LastDist = 100,
		Type = 0,	-- for use with Filir's customized code
		}
AlchTarget = { ID = -1, Previous = -1, Lock = false, Swap = 0,
		TicksSpent = 0, LastTick = 0, LastDist = 100 }
PauseAttackSkills = false
IgnoredTargets = { }
HomunTargetOf = { update=0, }
OwnerTargetOf = { update=0, }

-- Override functions for target acquisition
--	(keep in mind, these will ignore aggro/passive modes if set!)
HomunAcquireOverride = nil
AlchAcquireOverride = nil

-----------------
-- HP Tracking --
-----------------

OwnerHPTracking = List.new()
HomunHPTracking = List.new()
OwnerHPDelta = { iteration = 0, second = 0 }
HomunHPDelta = { iteration = 0, second = 0 }

--------------------------------
-- Advanced Movement Commands --
--------------------------------

AMCLastTime = 0
AMCSequence = ""
AMCTarget = -1
AMCFullCommands = Table.new()
AMCSubParsers = Table.new()

---------------
-- Debugging --
---------------

CycleTime = { Total=0, Count=0, Between=0, Tick=0, Longest=0, }
NetworkPacketsSent = 0
LastLogLine = ""
Logs = List.new()
